#include <SoftwareSerial.h>

volatile long AddressRobot;
volatile byte ChannelRobot;
volatile byte MSB_Address;
volatile byte LSB_Address;
volatile long rockerR_X;
volatile long rockerR_Y;
volatile long rockerL_X;
volatile long rockerL_Y;
volatile int ButtonUp;
volatile int ButtonDown;
volatile int ButtonLeft;
volatile int ButtonRight;
volatile int Button1;
volatile int Button2;
volatile int Button3;
volatile int Button4;
volatile int RocKeyL;
volatile int RocKeyR;
volatile char state_rocker;
volatile char state_button;

SoftwareSerial mySerial(3,2);

void setup(){
  AddressRobot = 7;
  ChannelRobot = 17;
  MSB_Address = ((AddressRobot>>8)&0x000000FF);
  LSB_Address = (AddressRobot&0x000000FF);
  mySerial.begin(115200);
  rockerR_X = 0;
  rockerR_Y = 0;
  rockerL_X = 0;
  rockerL_Y = 0;
  ButtonUp = 0;
  ButtonDown = 0;
  ButtonLeft = 0;
  ButtonRight = 0;
  Button1 = 0;
  Button2 = 0;
  Button3 = 0;
  Button4 = 0;
  RocKeyL = 0;
  RocKeyR = 0;
  state_rocker = 0;
  state_button = 0;
  pinMode(4, INPUT);
  pinMode(7, INPUT);
  pinMode(5, INPUT);
  pinMode(6, INPUT);
  pinMode(8, INPUT);
  pinMode(9, INPUT);
  pinMode(10, INPUT);
  pinMode(11, INPUT);
  pinMode(A4, INPUT);
  pinMode(A3, INPUT);
  pinMode(12, OUTPUT);
}

void GamePadCtrl(){
  rockerR_X = analogRead(A0);
  rockerR_Y = analogRead(A1);
  rockerL_X = analogRead(A6);
  rockerL_Y = analogRead(A7);
  ButtonUp = digitalRead(4);
  ButtonDown = digitalRead(7);
  ButtonLeft = digitalRead(5);
  ButtonRight = digitalRead(6);
  Button1 = digitalRead(8);
  Button2 = digitalRead(9);
  Button3 = digitalRead(10);
  Button4 = digitalRead(11);
  RocKeyR = digitalRead(A4);
  RocKeyL = digitalRead(A3);
  if (rockerR_Y > 600 || ButtonUp == 1) {
    if (state_rocker != 'A') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOA");
      delay(100);

    }
    state_rocker = 'A';

  } else if (rockerR_Y < 120 || ButtonDown == 1) {
    if (state_rocker != 'B') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOB");
      delay(100);

    }
    state_rocker = 'B';
  } else if (rockerR_X > 600 || ButtonLeft == 1) {
    if (state_rocker != 'C') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOC");
      delay(100);

    }
    state_rocker = 'C';
  } else if (rockerR_X < 123 || ButtonRight == 1) {
    if (state_rocker != 'D') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOD");
      delay(100);

    }
    state_rocker = 'D';
  } else if (rockerL_Y > 600) {
    if (state_rocker != 'F') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOF");
      delay(100);

    }
    state_rocker = 'F';
  } else if (rockerL_Y < 123) {
    if (state_rocker != 'G') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOG");
      delay(100);

    }
    state_rocker = 'G';
  } else if (rockerL_X < 123) {
    if (state_rocker != 'H') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOH");
      delay(100);

    }
    state_rocker = 'H';
  } else if (rockerL_X > 600) {
    if (state_rocker != 'I') { 
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOI");
      delay(100);

    }
    state_rocker = 'I';
  } else {
    if (state_rocker != 'E') {
      mySerial.write(MSB_Address);
      mySerial.write(LSB_Address);
      mySerial.write(ChannelRobot);
      mySerial.print("DOE");
      delay(200);
      mySerial.print("DOE");
      delay(100);

    }
    state_rocker = 'E';

  }

}

void LEDCtrl(){
    static u8 LEDFlag = 0;
    static unsigned long systick_ms_bak = 0;
    if(millis() - systick_ms_bak > 500) {
      systick_ms_bak = millis();
      if(LEDFlag) {
        digitalWrite(12,LOW);
      } else {
        digitalWrite(12,HIGH);  
      }
      LEDFlag = !LEDFlag;
    }
  }
void loop(){
  LEDCtrl();
  GamePadCtrl();
  }
